-- No longer Crypt0!
-- now its called Nim!
-- And it really is Nim!

-- first, we're going to use the following:
left = math.random(10,15)
-- last played move. 
last_move = 0
player_human = true -- human goes first

-- now, we're going to set up the rules.
-- the rules should be as simple as possible.
-- by default, NIM has only 3 rules
-- you can take 1 or 2 sticks
-- play flips from one player to another
-- player to take the last peice looses

-- load the font
-- its DejaVu Sans Mono. Its Free.
interface_font = pge.font.load("font.ttf", 16)
-- our background image. 
background = pge.texture.load("bg.png")
-- about screen.
aboutpage = pge.texture.load("about.png")
-- text color. 
white = pge.gfx.createcolor(0,255,0)

-- state of "did someone win?"
end_game = false

-- now for the main loop
while pge.running() do
    
    pge.gfx.startdrawing()

    -- we're going to draw the board and how many peices are left.
    background:activate()
    background:draweasy(0,0)
    
    if( player_human == false ) then
        -- the CPU player plays before we print out the status text, just because.
        
        if(left == 2) then
            last_move = 1
            left = left -last_move
        end
        
        if(left ==3  ) then
        
            -- we can force the player to loose.
            last_move = 2
            left = left-last_move
            
        else
        
            last_move = math.random(1,2)
            left = left - last_move
        
        end
        -- the to-play player is HUMAN.
        player_human = true
    else
    
        pge.controls.update()
        if(pge.controls.pressed(PGE_CTRL_CROSS)) then
            last_move = 1
            left = left - last_move;
            player_human = false
            -- the To-play player is CPU.
        end
        if (pge.controls.pressed(PGE_CTRL_CIRCLE)) then
            last_move = 2
            left = left - last_move
            player_human = false
        end
        if(pge.controls.pressed(PGE_CTRL_START)) then
            pge.exit()
        end
        if(pge.controls.pressed(PGE_CTRL_SELECT)) then
        
        -- this is my favorite hack.
        -- we're going to paint to the current buffer (we'll assume it hasnt been tampered with otherwise)
        aboutpage:activate()
        aboutpage:draweasy(0,0)
        pge.gfx.enddrawing()
	-- now, our *previous* state is stored in the buffer we just swapped out. 
        pge.gfx.swapbuffers()
        -- Get our current control scheme.
        pge.controls.update()
        -- wait for the player to press SELECT, or PGE to stop running
        while ( pge.controls.pressed(PGE_CTRL_SELECT) == false and pge.running() ) do pge.controls.update() end
        -- now, we swap *back* the buffers. 
        pge.gfx.swapbuffers()
        -- we had to have been coming from a draw scheme on that buffer, so lets continue it.
        pge.gfx.startdrawing()
        
        end
        
        
    end
    
    -- put our font into the active framebuffer.
    interface_font:activate()
    -- white is really "green" but what the heck.
    if(player_human == true) then
    interface_font:printcenter(90,white, string.format( "remaining: %i, Computer took %i", left, last_move ) )
    else
    interface_font:printcenter(90,white, string.format( "remaining: %i, Human took %i", left, last_move ) )
    end
    
    
    
    if(left <2 and player_human == true ) then
    
        interface_font:printcenter(150, white, "Human Looses.")
        left = math.random(10,20)
        end_game = true
        
    end
    if (left < 2 and player_human == false ) then
        interface_font:printcenter(150, white, "Computer Looses.")
        left=math.random(10,20)
        end_game = true
    end

     
    -- who's going to move?
    if(player_human == true and end_game == false) then
    
        interface_font:printcenter(250, white, "Human to move")
    end
    if (player_human == false and end_game == false) then
        interface_font:printcenter(250, white, "Computer to move")
        
    
    end

    -- we're at an endgame (someone lost!)
    if(end_game) then
        interface_font:printcenter(180, white, "Press X to start a new game!")
    end
    -- lets stop drawing now...
    pge.gfx.enddrawing()
    
    -- we have two graphics buffers...
    pge.gfx.swapbuffers()
    
    if(human_player == true) then pge.delay(math.random(100000,500000)) end
    
    if(end_game == true) then
    
        pge.controls.update()
        while(pge.controls.pressed(PGE_CTRL_CROSS) == false and pge.running() ) do if(pge.controls.pressed(PGE_CTRL_START)) then pge.exit() end pge.controls.update() end
        
        end_game = false
        
        
    
    end
    
end
